// write to a text file
// created by Zachary Seldess, 07/04/11
// Visualization Lab, King Abdullah University of Science and Technology
// Copyright  2011 King Abdullah University of Science and Technology. Some Rights Reserved.

import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.lang.StringBuilder;
import java.io.*;
import com.cycling74.max.*;

public class writeText extends MaxObject {

	private String path;	
	private File filename;
	private String contents = "";
	private StringBuilder sb = new StringBuilder(contents);
	
	writeText() {
		declareIO(1,1);
		setInletAssist(0, "messages to save text file");
		setOutletAssist(0, "bang upon save completion");
		createInfoOutlet(false);
		post("writeText by Zachary Seldess. Build July 4 2011.");
		post("Copyright  2011 King Abdullah University of Science and Technology. Some Rights Reserved."); 
	}

	public void anything(String msg, Atom[] args) {	

		if (msg.equals("write")) {
			if (args.length == 0) { // if no filename provided, generate one
				try {
					path = new java.io.File(".").getCanonicalPath();
					filename = new File(path + "writeText_" + getDateTime() + ".txt");
					FileWriter fstream = new FileWriter(filename);
					BufferedWriter writer
					writer.write(sb.toString());
					writer.flush();
					writer.close();
					outlet(0, "bang");				
				}
				catch (Exception e) {
					postError(e);
				}				
			}
			else {
				try {
					filename = new File(args[0].toString());
					FileWriter writer = new FileWriter(filename);
					writer.write(sb.toString());
					writer.flush();
					writer.close();
					outlet(0, "bang");
				}
				catch (Exception e) {
					postError(e);
				}
			}
		}
		
		else if (msg.equals("clear")) { // clear contents of StringBuilder object
			int len = sb.length();
			sb.delete(0, len);
		}
		
		else if (msg.equals("getLength")) { // get character length of StringBuilder object
			int len = sb.length();
			outlet(0, "length " + len);
		}
		
		else {
			String cmd = msg; // start building cmd string
			for (int i = 0; i < args.length; i++) {
				cmd = cmd + " " + args[i].toString(); // append args to end of cmd string
			}
			//post("writeText: " + cmd);
			sb.append(cmd); // append cmd string to StringBuilder object
		}			
	}

	private String getDateTime() {  
	    DateFormat df = new SimpleDateFormat("yyyy-MM-dd_hh:mm:ss");  
	    //df.setTimeZone(TimeZone.getTimeZone("PST"));  
	    return df.format(new Date());  
	}
	
	private void postError(Exception e) {
		post("writeText: " + e);
	}
		
}














